package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import flashx.textLayout.formats.BackgroundColor;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		//		[Embed(source = "data/music.mp3")] public static var SndMusic:Class;

		private var rhythm:Array = [
			[
				0,0,
				0,0,
				1,0,
				1,0,
				1,0,
				0,0,
				0,0,
				0,0,
				0,0,
				0,0,
				1,1,
				1,0,
				1,0,
				0,0,
				0,0,
				0,0,
			],
			[
				1,0,
				0,0,
				0,0,
				1,0,
				0,0,
				0,0,
				0,0,
				1,0,
				0,0,
				1,0,
				0,0,
				1,0,
				0,0,
				0,0,
				0,0,
				0,0,
				
				
				1,0,
				0,0,
				1,1,
				0,1,
				0,0,
				1,0,
				0,0,
				1,0,
				0,0,
				1,0,
				0,0,
				1,0,
				0,0,
				1,0,
				0,0,
				0,0,
			],						
			[
				1,0,
				1,0,
				1,0,
				0,0,
				1,1,
				1,0,
				1,0,
				0,0,
			],					
			[
				1,0,
				1,0,
				1,1,
				1,0,0,
				1,0,
				1,0,
				1,1,
				1,0,				
			],						
			[
				1,0,
				1,0,
				1,0,
				0,0,
				1,1,
				1,0,
				1,0,
				0,0,
			],					
			[
				1,0,
				1,0,
				1,1,
				1,0,0,
				1,0,
				1,0,
				1,1,
				1,0,				
			],						
			[
				1,0,
				1,0,
				1,0,
				0,0,
				1,1,
				1,0,
				1,0,
				0,0,
			],					
			[
				1,0,
				1,0,
				1,0,
				1,0,
				1,0,
				1,0,
				1,0,
				1,0,				
			]
		];
				
		private var hline:FlxSprite;
		public override function create():void
		{
				hline = new FlxSprite(150,FlxG.height/2);
				hline.createGraphic(20,1,0xffffffff);
				hline.color = 0x999999;
				add(hline);
				g = new FlxGroup();
				add(g);
				successbar = new FlxSprite(150+25,FlxG.height);
				successbar.createGraphic(10,FlxG.height,0xffff0000);
				add(successbar);
		}
		
		private var g:FlxGroup;
		private var t:Number=0;
		private var beatlength:Number=0.2;
		private var curbeat:int=0;
		private var successbar:FlxSprite;
		private var success:Number=0;
		private var successesneeded:Number=9;
		public override function update():void
		{		
			super.update();
			var s:FlxSprite;
			for (var i:int=g.members.length-1;i>=0;i--)
			{
				s = g.members[i];
				s.y+=(80+(FlxG.level*4))*FlxG.elapsed;
				if (s.y>FlxG.height)
				{
					if (s.color==0xff0000)
					{
						success -= 1/successesneeded;
						if (success<0)
						{
							success=0;
						}
						
						successbar.y = FlxG.height*(1-success);
					}
					g.remove(s,true);
				}
			}
			
			t+=FlxG.elapsed;
			if (t>=beatlength)
			{
				t-=beatlength;
				curbeat=(curbeat+1)%rhythm[FlxG.level].length;
				if (rhythm[FlxG.level][curbeat]==1)
				{
					s = new FlxSprite(155,-10);
					s.createGraphic(10,10);	
					s.color=0xff0000;
					g.add(s);
				}
			}
			if (FlxG.keys.justPressed("SPACE"))
			{
				hline.color = 0xffffff;
				var found:Boolean=false;
				for (i=g.members.length-1;i>=0;i--)
				{
					s = g.members[i];
					if (s.overlaps(hline))
					{
						s.color = 0x00ff00;
						found=true;
						
						success += 1/successesneeded;
						if (success>=1)
						{
							success=1;
							FlxG.level++;
							FlxG.state = new TitleState();
							return;
						}
						successbar.y = FlxG.height*(1-success);
					}
				}
				if (found==false)
				{
					s = new FlxSprite(150+5,hline.y+1);
					s.createGraphic(10,10);	
					s.color=0xff0000;
					g.add(s);
					
				}
			}
			else
			{
				hline.color = 0x999999;				
			}
		}
		
	}
}