package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import flashx.textLayout.formats.BackgroundColor;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class TitleState extends FlxState
	{
		public var speech:Array = [
				[
					"A young woman was sent away by her cruel mother to marry a despicable  man",
					"He would beat her thrice daily, and call her the most terrible names"
				],
				[
					"To his delight, she eventually bore him a daughter - ",
					"But the woman could take no more, and filed for divorce.",
					"The judge did not take kindly to her display of initiative.",
					"And banged his gavel whenever she tried to defend herself",
					],
				[
					"She would have to bring up her daughter alone, with no support from the father",
					"She would have to go live with her sister, while her ex-husband would be free to cavort all around the land.",
					"One night, when passing by, he approached his daughter's window",
					"and he began to tap",
				],
				[
					"He roused his daughter, and spoke with her :",
					"\"My dear daughter, who I love as much as any daughter\"",
					"\"Would you like a baby brother?\"",
					"\"I'm sure you would love a baby brother.\"",
					"\"Just as I would love a son by your mother\"",
					"\"If you can trick your mother to go to the barn tomorrow night\"",
					"\"Then I will give you a lovely baby brother\"",
					"And so, on the following evening, she said to her mother :",
					"\"Mother, the barn roof is leaking\"",
					"Her mother protested that it was not even raining",
					"\"Mother, the barn roof is leaking, you must mend it!\"",
					"She was confused, but went out to the barn to have a look..."
				],
				[
					"Nine months later, the mother bore her sister a new brother.",
					"The daughter doted on her brother.",
					"Until again, when passing by one night, her father came,",
					"He came and tapped on her window",
				],
				[
					"He roused his daughter, and spoke with her :",
					"\"My dear daughter, who I love as much as any daughter\"",
					"\"Would you like another baby brother?\"",
					"\"I'm sure you would love another baby brother.\"",
					"\"Just as I would love another son by your mother\"",
					"\"If you can trick your mother to go to the barn tomorrow night\"",
					"\"Then I will give you another lovely baby brother\"",
					"And so, on the following evening, she said to her mother :",
					"\"Mother, the cow in the barn has bloat\"",
					"Her mother protested that the cows were still eating grass",
					"\"Mother, the cow in the barn has bloat, you must tend to her!\"",
					"She was confused, but went out to the barn to have a look..."
					],
				[
					"Nine months later, she bore her children another brother.",
					"The daughter doted on her two brothers - they were inseparable.",
					"Once again, when passing by one night, her father came,",
					"He came and tapped on her window",
				],
				[
					"He roused his daughter, and spoke with her :",
					"\"My dear daughter, who I love as much as any daughter\"",
					"\"Would you like a third baby brother?\"",
					"\"I'm sure you would love a third baby brother.\"",
					"\"Just as I would love a third son by your mother\"",
					"\"If you can trick your mother to go to the barn tomorrow night\"",
					"\"Then I will give you a third baby brother\"",
					"She replied back to him",
					"My dear father, there is no longer any need for tricks,",
					"I will bring her to you in evening.",
					"And the following evening, she told her two brothers to grab their mother",
					"And to bring her to the barn",
				],
				[
					"Nine months later, she bore her children a third brother,",
					"Dying in the process.",
					"Her children mourned for many months,",
					"She had given them each other, and for that they would miss her dearly.",
				]
			];
		
		private var time:Number=0;
		private var t:FlxText;
		private var index:int=0;
		public override function create():void
		{
			t = new FlxText(10,10,FlxG.width-20,"");
			t.size = 16;
			t.alpha=0;
			add(t);
			SetText();
		}
		
		private function SetText():void
		{
			t.text = speech[FlxG.level][index];
		}
		
		public override function update():void
		{
			time+=FlxG.elapsed;
			t.alpha= (time<0.5 ? 2*time : 1);
			
			if (time>=0.5 && FlxG.keys.justPressed("SPACE"))
			{
				index++;
				if (index>=speech[FlxG.level].length)
				{
					if (FlxG.level<8)
					{
						FlxG.state = new GameState();
					}
					else
					{
						FlxG.level=0;
						FlxG.state = new ProperTitle();
					}
				}
				else
				{
					SetText();
				}
			}
		}
		
	}
}